%global dlrn_nvr tripleo-common-9.4.1.dev152-0.20190119050430.261de49
%global dlrn 1
%define upstream_version 9.4.1.dev152
# guard for package OSP does not support
%global rhosp 1

%{!?upstream_version: %global upstream_version %{version}}
%global upstream_name tripleo-common

%if 0%{?fedora}
%global with_python3 1
%endif

%global common_desc Python library for code used by TripleO projects.

%{?!_licensedir:%global license %%doc}

Name:           openstack-tripleo-common
Summary:        Python library for code used by TripleO projects.
Version: 9.5.0
Release: 2%{?dist}
License:        ASL 2.0
URL:            https://github.com/rdo-management/tripleo-common

Source0: http://tarballs.openstack.org/%{upstream_name}/%{upstream_name}-%{version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=9.5.0
Patch0001: 0001-DOWNSTREAM-ONLY-container-build-overrides.patch
Patch0002: 0002-DOWNSTREAM-ONLY-exclude-neutron-vpn-agent-for-l3-con.patch
Patch0003: 0003-DOWNSTREAM-ONLY-Set-container-image-names-for-downst.patch
Patch0004: 0004-DOWNSTREAM-ONLY-Remove-congress-api-from-overcloud_c.patch
Patch0005: 0005-DOWNSTREAM-ONLY-Remove-rsyslog-container-image.patch
Patch0006: 0006-DOWNSTREAM-ONLY-add-ENV-container-oci.patch
Patch0007: 0007-DOWNSTREAM-ONLY-Set-downstream-container-images-for-.patch
Patch0008: 0008-DOWNSTREAM_ONLY-set-tag_from_label-to-version-releas.patch
Patch0009: 0009-Add-container-images-for-openshift-3.11.patch
Patch0010: 0010-Install-ironic-staging-drivers-in-ironic-conductor.patch
Patch0011: 0011-downstream-ironic-conductor-Add-pkgs-for-RHV-integra.patch
Patch0012: 0012-Revert-downstream-only-Fix-nova-api-healthcheck.patch
Patch0013: 0013-Additional-images-for-openshift-services.patch
Patch0014: 0014-Fix-rebase-issues.patch
Patch0015: 0015-Append-qemu-img-to-Mistral-executor-package-list.patch
Patch0016: 0016-Use-versioned-image-for-gluster-and-heketi.patch
Patch0017: 0017-Specify-Octavia-amphora-image-hw_architecture-proper.patch
Patch0018: 0018-Stops-growth-of-massive-dentry-cache-growth.patch
Patch0019: 0019-DOWNSTREAM-ONLY-Do-not-re-tag-OpenShift-images.patch
Patch0020: 0020-Get-osa-container-image-from-tripleo-common-defaults.patch
Patch0021: 0021-Introduce-a-plan-option-to-replace-config-download-d.patch
Patch0022: 0022-Add-ability-to-run-osa-playbooks-from-tripleo-deploy.patch
Patch0023: 0023-Pass-additional-args-to-tripleo-deploy-openshift-as-.patch
Patch0024: 0024-Skip-ssh_known_hosts-tasks-in-check-mode.patch
Patch0025: 0025-Add-missing-queue_name-input-parameter-for-listing-v.patch
Patch0026: 0026-Install-ipmitool-in-the-mistral_executor-image.patch
Patch0027: 0027-Don-t-always-validate-heat-stack-when-adding-paramet.patch
Patch0028: 0028-Remove-amp_hw_arch-from-octavia_post.patch

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  openstack-macros

Requires: skopeo
Requires: ansible
# Ansible roles used by TripleO
Requires: ansible-role-container-registry
Requires: ansible-role-tripleo-modify-image
Requires: ansible-pacemaker
Requires: ansible-tripleo-ipsec
%if 0%{rhosp} == 1
Requires: ansible-role-redhat-subscription
%endif

Requires: %{name}-containers = %{version}-%{release}
%if 0%{?with_python3}
Requires: python3-%{upstream_name}
%else
Requires: python2-%{upstream_name}
%endif

Provides:  tripleo-common = %{version}-%{release}
Obsoletes: tripleo-common < %{version}-%{release}

%description
%{common_desc}

%if 0%{?with_python3}
%package -n python3-%{upstream_name}
Summary:        Python library for code used by TripleO projects.

BuildRequires:  python3-setuptools
BuildRequires:  python3-devel
BuildRequires:  python3-pbr
BuildRequires:  python3-cryptography
BuildRequires:  python3-docker
BuildRequires:  python3-GitPython
BuildRequires:  python3-fixtures
BuildRequires:  python3-glanceclient
BuildRequires:  python3-heatclient
BuildRequires:  python3-ironicclient
BuildRequires:  python3-ironic-inspector-client
BuildRequires:  python3-metalsmith
BuildRequires:  python3-mistral-lib
BuildRequires:  python3-mistralclient
BuildRequires:  python3-novaclient
BuildRequires:  python3-oslo-concurrency
BuildRequires:  python3-oslo-i18n
BuildRequires:  python3-oslo-log
BuildRequires:  python3-oslo-utils
BuildRequires:  python3-oslotest
BuildRequires:  python3-paramiko
BuildRequires:  python3-passlib
BuildRequires:  python3-swiftclient
BuildRequires:  python3-tenacity
BuildRequires:  python3-testtools
BuildRequires:  python3-zaqarclient
BuildRequires:  python3-yaml

Requires: python3-GitPython
Requires: python3-jinja2
Requires: python3-glanceclient >= 1:2.8.0
Requires: python3-heatclient >= 1.10.0
Requires: python3-ironic-inspector-client >= 1.5.0
Requires: python3-ironicclient >= 2.3.0
Requires: python3-keystoneclient
Requires: python3-novaclient >= 1:9.1.0
Requires: python3-metalsmith >= 0.5.0
Requires: python3-mistral-lib >= 0.3.0
Requires: python3-mistralclient >= 3.1.0
Requires: python3-netaddr
Requires: python3-netifaces
Requires: python3-oslo-concurrency >= 3.26.0
Requires: python3-oslo-config >= 2:5.2.0
Requires: python3-oslo-log >= 3.36.0
Requires: python3-oslo-utils >= 3.33.0
Requires: python3-six >= 1.10.0
Requires: python3-docker >= 2.4.2
Requires: python3-passlib
Requires: python3-keystoneauth1 >= 3.4.0
Requires: python3-pbr >= 2.0.0
Requires: python3-zaqarclient >= 1.0.0
Requires: python3-paramiko

Requires: python3-tenacity >= 4.4.0
Requires: python3-cryptography

%{?python_provide:%python_provide python3-%{upstream_name}}

%description -n python3-%{upstream_name}
%{common_desc}
%else

%package -n python2-%{upstream_name}
Summary:        Python library for code used by TripleO projects.

BuildRequires:  python2-setuptools
BuildRequires:  python2-devel
BuildRequires:  python2-pbr
BuildRequires:  python2-cryptography
BuildRequires:  python2-docker
BuildRequires:  python2-futures
BuildRequires:  GitPython
BuildRequires:  python2-fixtures
BuildRequires:  python2-glanceclient
BuildRequires:  python2-heatclient
BuildRequires:  python2-ironicclient
BuildRequires:  python2-ironic-inspector-client
BuildRequires:  python2-metalsmith
BuildRequires:  python2-mistral-lib
BuildRequires:  python2-mistralclient
BuildRequires:  python2-novaclient
BuildRequires:  python2-oslo-concurrency
BuildRequires:  python2-oslo-i18n
BuildRequires:  python2-oslo-log
BuildRequires:  python2-oslo-utils
BuildRequires:  python2-oslotest
BuildRequires:  python2-paramiko
BuildRequires:  python2-passlib
BuildRequires:  python2-swiftclient
BuildRequires:  python2-tenacity
BuildRequires:  python2-testtools
BuildRequires:  python2-zaqarclient
BuildRequires:  python-yaml

Requires: GitPython
Requires: python2-jinja2
Requires: python2-glanceclient >= 1:2.8.0
Requires: python2-heatclient >= 1.10.0
Requires: python-ironic-inspector-client >= 1.5.0
Requires: python2-ironicclient >= 2.3.0
Requires: python2-keystoneclient
Requires: python2-novaclient >= 1:9.1.0
Requires: python2-metalsmith >= 0.5.0
Requires: python2-mistral-lib >= 0.3.0
Requires: python2-mistralclient >= 3.1.0
Requires: python2-netaddr
Requires: python-netifaces
Requires: python2-oslo-concurrency >= 3.26.0
Requires: python2-oslo-config >= 2:5.2.0
Requires: python2-oslo-log >= 3.36.0
Requires: python2-oslo-utils >= 3.33.0
Requires: python2-six >= 1.10.0
Requires: python2-docker >= 2.4.2
Requires: python2-passlib
Requires: python2-keystoneauth1 >= 3.4.0
Requires: python2-pbr >= 2.0.0
Requires: python2-zaqarclient >= 1.0.0
Requires: python-paramiko
Requires: python2-tenacity >= 4.4.0
Requires: python2-cryptography
Requires: python2-futures

%{?python_provide:%python_provide python2-%{upstream_name}}

%description -n python2-%{upstream_name}
%{common_desc}

%endif

%prep
%autosetup -n %{upstream_name}-%{version} -S git
rm -rf *.egg-info

# Remove the requirements file so that pbr hooks don't add it
# to distutils requires_dist config
%py_req_cleanup

%build
%if 0%{?with_python3}
%py3_build
%else
%py2_build
%endif

%install
%if 0%{?with_python3}
%py3_install
%else
%py2_install
%endif

# TODO remove when https://review.openstack.org/554926 is merged
touch %{buildroot}%{_bindir}/tripleo-overcloud-cert

# TODO remove when https://review.openstack.org/#/c/605399/
touch %{buildroot}%{_bindir}/tripleo-deploy-openshift

if [ -d %{buildroot}/%{_datadir}/%{upstream_name} ]; then
  mv %{buildroot}/%{_datadir}/%{upstream_name} %{buildroot}/%{_datadir}/%{name}
else
  # Before https://review.openstack.org/#/c/327830/3/setup.cfg
  mkdir -p %{buildroot}/%{_datadir}/%{name}
  if [ -d image-yaml ]; then
    install -d -m 755 %{buildroot}/%{_datadir}/%{name}
    cp -ar image-yaml %{buildroot}/%{_datadir}/%{name}
  fi
fi
ln -s %{name} %{buildroot}%{_datadir}/%{upstream_name}

if [ -d workbooks ]; then
  cp -ar workbooks %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/workbooks
fi

if [ -d playbooks ]; then
  cp -ar playbooks %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/playbooks
fi

if [ -d healthcheck ]; then
  cp -ar healthcheck %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/healthcheck
fi

if [ ! -d roles ]; then
  mkdir -p %{buildroot}/%{_datadir}/ansible/roles
fi

if [ ! -d ansible_plugins ]; then
  mkdir -p %{buildroot}/%{_datadir}/ansible/plugins
fi

mkdir -p %{buildroot}/%{_datadir}/%{name}-containers
mv %{buildroot}/%{_datadir}/%{name}/container-images %{buildroot}/%{_datadir}/%{name}-containers/
# compat symlink
ln -s ../%{name}-containers/container-images  %{buildroot}/%{_datadir}/%{name}/

if [ -d heat_docker_agent ]; then
  cp -ar heat_docker_agent %{buildroot}/%{_datadir}/%{name}/
else
  mkdir -p %{buildroot}/%{_datadir}/%{name}/heat_docker_agent
fi

install -p -D -m 440 sudoers %{buildroot}%{_sysconfdir}/sudoers.d/%{upstream_name}

if [ -f %{buildroot}%{_bindir}/upgrade-non-controller.sh ]; then
  rm -rf %{buildroot}%{_bindir}/upgrade-non-controller.sh
fi

%check
%if 0%{?with_python3}
export PYTHON=/usr/bin/python3
# (TODO) ignoring unit test errors as reported in https://bugs.launchpad.net/tripleo/+bug/1778903
%{__python3} setup.py test||true
%else
%{__python2} setup.py test
%endif

%description
%{common_desc}

%package containers
Summary: Files for building TripleO containers

%description containers
This package installs the files used to build containers for TripleO.

%package container-base
Summary: Package for the TripleO base container image
Requires: puppet
Requires: lsof
Requires: hostname

%description container-base
This package installs the dependencies and files which are required on the base
TripleO container image.

%package devtools
Summary: A collection of tools for TripleO developers and CI
Requires: %{name} = %{version}-%{release}

%description devtools
This package installs the TripleO tools for developers and CI that typically
don't fit in a product.

%files
%license LICENSE
%doc README.rst AUTHORS ChangeLog
%{_prefix}/lib/heat/undercloud_heat_plugins
%{_datadir}/%{name}
%{_datadir}/%{upstream_name}
%{_sysconfdir}/sudoers.d/%{upstream_name}
%{_datadir}/ansible/roles
%{_datadir}/ansible/plugins

%if 0%{?with_python3}
%files -n python3-%{upstream_name}
%license LICENSE
%doc README.rst AUTHORS ChangeLog
%{python3_sitelib}/tripleo_common*
%exclude %{python3_sitelib}/tripleo_common/test*
%{_bindir}/tripleo-build-images
%{_bindir}/upload-puppet-modules
%{_bindir}/upload-swift-artifacts
%{_bindir}/run-validation
%{_bindir}/tripleo-config-download
%{_bindir}/tripleo-container-image-prepare
%{_bindir}/tripleo-deploy-openshift
%{_bindir}/tripleo-overcloud-cert
%{_bindir}/create_freeipa_enroll_envfile.py
%else
%files -n python2-%{upstream_name}
%license LICENSE
%doc README.rst AUTHORS ChangeLog
%{python2_sitelib}/tripleo_common*
%exclude %{python2_sitelib}/tripleo_common/test*
%{_bindir}/tripleo-build-images
%{_bindir}/upload-puppet-modules
%{_bindir}/upload-swift-artifacts
%{_bindir}/run-validation
%{_bindir}/tripleo-config-download
%{_bindir}/tripleo-container-image-prepare
%{_bindir}/tripleo-deploy-openshift
%{_bindir}/tripleo-overcloud-cert
%{_bindir}/create_freeipa_enroll_envfile.py
%endif

%files containers
%{_datadir}/%{name}-containers/container-images

%files container-base
%{_bindir}/bootstrap_host_exec
%{_bindir}/bootstrap_host_only_eval
%{_bindir}/bootstrap_host_only_exec
%{_datadir}/%{name}/healthcheck

%files devtools
%{_bindir}/pull-puppet-modules

%changelog
* Sun Apr 14 2019 Nir Magnezi <nmagnezi@redhat.com> 9.5.0-2
- Remove amp_hw_arch from octavia_post (rhbz#1699612)

* Wed Mar 27 2019 Steve Linabery <slinaber@redhat.com> 9.5.0-1
- Update to 9.5.0
- Don't always validate heat stack when adding parameters
- Install ipmitool in the mistral_executor image
- Add missing queue_name input parameter for listing validations

* Mon Mar 18 2019 Alex Schultz <aschultz@redhat.com> 9.4.1-0.20190119050435
- Skip ssh_known_hosts tasks in check mode (rhbz#1684864)

* Wed Mar 13 2019 Martin André <m.andre@redhat.com> 9.4.1-0.20190119050434.261de49
- Pass additional args to tripleo-deploy-openshift as ansible options (rhbz#1660066)
- Add ability to run osa playbooks from tripleo-deploy-openshift (rhbz#1660066)
- Introduce a --plan option to replace --config-download-dir (rhbz#1660066)
- Get osa container image from tripleo-common defaults (rhbz#1660066)
- [DOWNSTREAM-ONLY] Do not re-tag OpenShift images (rhbz#1659183)
- Stops growth of massive dentry cache growth (rhbz#1685732)

* Tue Mar 05 2019 Nir Magnezi <nmagnezi@redhat.com> 9.4.1-0.20190119050433.261de49
- Specify Octavia amphora image hw_architecture property in Glance (rhbz#1685435)
- Fix a PEP8 error (rhbz#1685435)
- Use versioned image for gluster and heketi (rhbz#1679330)

* Mon Feb 25 2019 Thierry Vignaud <tvignaud@redhat.com> 9.4.1-0.20190119050432.261de49
- Append qemu-img to Mistral executor package list (rhbz#1593341)

* Tue Feb 05 2019 Thierry Vignaud <tvignaud@redhat.com> 9.4.1-0.20190119050431.261de49
- Rebase over RDO (rhbz#1672450)

* Mon Jan 28 2019 Emilien Macchi <emilien@redhat.com> 9.4.1-0.20181012010891
- Check for physical_resource_id before getting deployments (rhbz#1667020)

* Fri Jan 25 2019 Carlos Goncalves <cgoncalves@redhat.com> 9.4.1-0.20181012010890
- Option to upload Octavia amphora img in RAW format (rhbz#1593341)

* Tue Jan 15 2019 Mike Burns <mburns@redhat.com> 9.4.1-0.20181012010889
- IPv6 healthcheck fixes for nova-vnc-proxy (rhbz#1660091)
- Move Octavia config opts to common config directory (rhbz#1655431)

* Tue Jan 15 2019 Mike Burns <mburns@redhat.com> 9.4.1-0.20181012010888
- Workaround ssh_known_hosts changes not being propagated to containers (rhbz#1664165)
- Look for lower-case hostname when adding to ssh_known_hosts (rhbz#1664165)

* Tue Dec 18 2018 “Beth <belwell@redhat.com> 9.4.1-0.20181012010886
- Fix DeploymentStatusAction KeyError (rhbz#1659415)

* Mon Dec 17 2018 “Beth <belwell@redhat.com> 9.4.1-0.20181012010885
- Add a way to update ContainerImagePrepare params (rhbz#1648918)
- Fix environments sorting (rhbz#1651159)

* Fri Dec 07 2018 Giulio Fidente <gfidente@redhat.com> 9.4.1-0.20181012010884
- Add python-notario package to mistral-executor container (rhbz#1654851)

* Thu Dec 06 2018 Martin André <m.andre@redhat.com> 9.4.1-0.20181012010883
- Additional images for openshift services (rhbz#1655576)
- Catch heat exceptions in DeployStackAction (rhbz#1655886)

* Mon Dec 03 2018 “Beth <belwell@redhat.com> 9.4.1-0.20181012010882
- Exit when container is missing or empty when downloading logs (rhbz#1647751)
- Select message IDs properly when publishing to swift (rhbz#1647751)

* Wed Nov 28 2018 Jiri Stransky <jistr@redhat.com> 9.4.1-0.20181012010881
- Set DeployIdentifier on update/upgrade/ffwd prepare actions (rhbz#1652924)

* Tue Nov 27 2018 Emilien Macchi <emilien@redhat.com> 9.4.1-0.20181012010880
- image_uploader: use /v2 suffix to validate SSL (rhbz#1652989)
- Cache swift responses in process_environments_and_files (rhbz#1647566)
- Don't reset parameter cache in a loop (rhbz#1647566)
- Fix rotate_fernet_keys workflow to not use heat deployment (rhbz#1639495)

* Thu Nov 22 2018 Martin Schuppert <mschuppert@redhat.com> 9.4.1-0.20181012010879
- Fix nova-api healthcheck (rhbz#1651931)
- Omit grep process in nova_api healthcheck. (rhbz#1651931)
- Revert "[downstream-only] Fix nova-api healthcheck" (rhbz#1651931)

* Wed Nov 21 2018 John Fulton <fulton@redhat.com> 9.4.1-0.20181012010878
- Update swift_backup workflow success status message (rhbz#1651776)

* Fri Nov 16 2018 Bob Fournier <bfournie@redhat.com> 9.4.1-0.20181012010877
- (downstream) - ironic-conductor - Add pkgs for RHV integration (rhbz#1646641)
- Install ironic-staging-drivers in ironic-conductor (rhbz#1646641)
- Increase size for security hardened images (rhbz#1636198)
- Fix config-download timeout (rhbz#1646691)
- Add httpd and mod_ssl packages to octavia api image (rhbz#1635341)

* Mon Nov 12 2018 Nir Magnezi <nmagnezi@redhat.com> 9.4.1-0.20181012010876.67bab16
- Add httpd and mod_ssl packages to octavia api image (rhbz#1635341)

* Thu Nov 08 2018 Carlos Goncalves <cgoncalves@redhat.com> 9.4.1-0.20181012010875.67bab16
- Stop installing octavia-amphora-image package (rhbz#1640024)

* Thu Nov 08 2018 Martin André <m.andre@redhat.com> 9.4.1-0.20181012010874.67bab16
- Add container images for openshift 3.11 (rhbz#1640287)
- Store prepare defaults in packaged yaml (rhbz#1640287)

* Wed Nov 07 2018 John Fulton <johfulto@redhat.com> 9.4.1-0.20181012010873.67bab16
- Run Mistral workflow to make temporary Swift URLs on upgrade (rhbz#1642462)

* Wed Nov 07 2018 Martin Schuppert <mschuppert@redhat.com> 9.4.1-0.20181012010872.67bab16
- [downstream-only] Fix nova-api healthcheck (rhbz#1637739)

* Tue Nov 06 2018 James Slagle <jslagle@redhat.com> 9.4.1-0.20181012010871.67bab16
- Add get_deployment_status to setup.cfg (rhbz#1646817)

* Mon Nov 05 2018 James Slagle <jslagle@redhat.com> 9.4.1-0.20181012010870.67bab16
- Delete old tarball from config container on download (rhbz#1645694)

* Fri Oct 26 2018 Martin André <m.andre@redhat.com> 9.4.1-0.20181012010869.67bab16
- Update patches

* Fri Oct 26 2018 Giulio Fidente <gfidente@redhat.com> 9.4.1-0.20181012010868.67bab16
- Update patches

* Thu Oct 25 2018 James Slagle <jslagle@redhat.com> 9.4.1-0.20181012010867.67bab16
- Sync state if needed during retrieval (rhbz#1637966)

* Tue Oct 23 2018 Giulio Fidente <gfidente@redhat.com> 9.4.1-0.20181012010866.67bab16
- Change ceph-ansible fetch directory format on upgrade from Q to R (rhbz#1639448)

* Mon Oct 22 2018 James Slagle <jslagle@redhat.com>  9.4.1-0.20181012010865.67bab16
- Update patches

* Thu Oct 18 2018 Martin André <m.andre@redhat.com> 9.4.1-0.20181012010864.67bab16
- Update patches

* Wed Oct 17 2018 Martin André <m.andre@redhat.com> 9.4.1-0.20181012010863.67bab16
- Add wrapper for openshift-ansible docker command (rhbz#1609309)
- Add openshift-ansible container image (rhbz#1609309 rhbz#1635293)

* Wed Oct 17 2018 Thierry Vignaud <tvignaud@redhat.com> 9.4.1-0.20181012010861.67bab16
- Set workflow status to success when manipulating deployment status (rhbz#1635053)
- [DOWNSTREAM-ONLY] Remove congress-api from overcloud_containers (rhbz#1535610 rhbz#1627049 rhbz#1638802)
- [DOWNSTREAM_ONLY] Fix tripleo-common after last sync

